/*
 * NBCT
 * Copyright (c) 2007-2008, Yoshitaka Kameya
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms,  with or without
 * modification,  are permitted provided that the following conditions
 * are met:
 * 
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions  in  binary  form  must  reproduce  the  above
 *    copyright notice,  this list of conditions  and  the following
 *    disclaimer  in  the  documentation  and/or   other   materials
 *    provided with the distribution.
 *  * Neither  the  name  of  Tokyo Institute of Technology  nor the
 *    names of its contributors may be used to  endorse  or  promote
 *    products derived from  this  software  without  specific prior
 *    written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS"  AND  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO,  THE IMPLIED WARRANTIES OF MERCHANTABILITY  AND FITNESS
 * FOR  A  PARTICULAR  PURPOSE  ARE  DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL,    SPECIAL,   EXEMPLARY,   OR   CONSEQUENTIAL   DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS;  OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT  LIABILITY,  OR  TORT  (INCLUDING  NEGLIGENCE  OR OTHERWISE)
 * ARISING  IN  ANY  WAY  OUT  OF  THE  USE  OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef NBC_VAR_H
#define NBC_VAR_H

#include "nbc_def.h"

OPTION nbc_opts[] = {
  { O_N_CAND,          "n-cand",          'a',  1 },
  { O_AUTOCLASS,       "autoclass",       'A',  0 },
  { O_DAEM,            "daem",            'b',  0 },
  { O_ITEMP,           "itemp",           'B',  1 },
  { O_SMOOTH_C,        "smooth-c",        'c',  1 },
  /* {NOT_AVAIL,       "",                'C',  0 }, */
  /* {NOT_AVAIL,       "",                'd',  0 }, */
  { O_MEM_PROB,        "mem-prob",        'D',  0 },
  { O_EPSILON,         "epsilon",         'e',  1 },
  { O_EVAL,            "eval",            'E',  1 },
  { O_TARGET,          "target",          'f',  1 },
  /* {NOT_AVAIL,       "",                'F',  0 }, */
  { O_SCORE,           "score",           'g',  1 },
  { O_N_JSPLIT,        "n-jsplit",        'G',  1 },
  { O_HELP,            "help",            'h',  0 },
  { O_READ_HPARAM,     "read-hparam",     'H',  0 },
  /* {NOT_AVAIL,       "",                'i',  0 }, */
  { O_ID,              "id",              'I',  1 },
  { O_OUTPUT,          "output",          'j',  1 },
  { O_LOG_VALUED,      "log-valued",      'J',  0 },
  { O_N_CLASS,         "n-class",         'k',  1 },
  { O_SMOOTH_MEAN,     "smooth-mean",     'K',  1 },
  { O_MAX_ITER_RESTART,"max-iter-restart",'l',  1 },
  { O_SMOOTH_VAR,      "smooth-var",      'L',  1 },
  { O_MAX_ITER,        "max-iter",        'm',  1 },
  /* {NOT_AVAIL,       "",                'M',  0 }, */
  { O_RESTART,         "restart",         'n',  1 },
  /* {NOT_AVAIL,       "",                'N',  0 }, */
  { O_N_SM,            "n-sm",            'o',  1 },
  { O_ALPHA,           "alpha",           'O',  1 },
#ifdef USE_ICONV
  { O_CODE_IN,         "code-in",         'p',  1 },
#endif
  /* {NOT_AVAIL,       "",                'P',  0 }, */
#ifdef USE_ICONV
  { O_CODE_OUT,        "code-out",        'q',  1 },
#endif
  /* {NOT_AVAIL,       "",                'Q',  0 }, */
  { O_SEED,            "seed",            'r',  1 },
  { O_READ_PARAM,      "read-param",      'R',  0 },
  { O_SUFFIX,          "suffix",          's',  1 },
  { O_SAVE_MESSAGE,    "save-msg",        'S',  0 },
  /* {NOT_AVAIL,       "",                't',  0 }, */
  { O_TAU,             "tau",             'T',  1 },
  { O_GAUSS,           "gauss",           'u',  1 },
  { O_UNCOMPRESS,      "uncompress",      'U',  0 },
  { O_VERBOSE,         "verbose",         'v',  0 },
  { O_HIDE_ATTR,       "hide-attr",       'V',  0 },
  { O_SMOOTH_A,        "smooth-a",        'w',  1 },
  /* {NOT_AVAIL,       "",                'W',  0 }, */
  { O_N_ATTR,          "n-attr",          'x',  1 },
  { O_XHELP,           "helpall",         'X',  0 },
  { O_IGNORE,          "ignore",          'y',  1 },
  /* {NOT_AVAIL,       "",                'Y',  0 }, */
  { O_RANK,            "rank",            'z',  1 },
  /* {NOT_AVAIL,       "",                'Z',  0 }, */
  { O_MIN_C_PARAM,     "min-c-param",     0,    1 },
  { O_MIN_SM_IMP,      "min-sm-imp",      0,    1 },
  { O_MIN_NEW_C_PARAM, "min-new-c-param", 0,    1 },
  { O_INIT_C,          "init-c",          0,    1 },
  { O_INIT_A,          "init-a",          0,    1 },
  /* { O_BDEU,         "bdeu",            0,    1 }, */
  { O_NORM_JMERGE,     "norm-jmerge",     0,    0 },
  { O_OCC_ORDER,       "occ-order",       0,    0 },
  { O_RANK_HIDE,       "hide-rank",       0,    0 },
  { O_PREC_OUT,        "prec-out",        0,    1 },
  { O_PREC_MSG,        "prec-msg",        0,    1 },
  { O_DISSIM,          "dissim",          0,    0 },
  { O_INPUT,           "input",           0,    1 },
  { -1, NULL,       0,  0 }
};

/* Global vars. for files */
char fname_base[MAX_FILENAME];         /* basename */
char fname_suffix[MAX_FILENAME];       /* suffix name */
char fname_freq[MAX_FILENAME_AUX];     /* occurrences of cases */
char fname_param[MAX_FILENAME_AUX];    /* parameters */
char fname_hparam[MAX_FILENAME_AUX];   /* hyperparameters */
char fname_dist[MAX_FILENAME_AUX];     /* dissimilarities */
char fname_memp[MAX_FILENAME_AUX];     /* membership probabilities */
char fname_log[MAX_FILENAME_AUX];      /* log (general) */
char fname_cluster[MAX_FILENAME_AUX];  /* clustering */
char fname_rank[MAX_FILENAME_AUX];     /* relevance analysis */
char fname_rank_sm[MAX_FILENAME_AUX];  /* relevance analysis (SMEM) */
char fname_msg[MAX_FILENAME_AUX];      /* messages */
FILE *fp_log = NULL;
FILE *fp_msg = NULL;
FILE *fp_sm  = NULL;

/* Global vars. for code conversion */
#ifdef USE_ICONV
#  ifdef CHARCODE
iconv_t cd_sys_in, cd_sys_out;  /* Discriptor of the converter (system's default) */
#  endif
iconv_t cd_in, cd_out;          /* Discriptor of the converter (user) */
#endif
char *buf_base = NULL;
char *buf_sys  = NULL;
char *buf_delim = NULL;
char *buf_cout  = NULL;

/* Global vars. for time measuring */
FLOAT_T stime_read;
FLOAT_T stime_em;
FLOAT_T stime_memp;
FLOAT_T stime_kl_dist;
FLOAT_T etime_read;
FLOAT_T etime_em;
FLOAT_T etime_memp;
FLOAT_T etime_kl_dist;
FLOAT_T stime_lap_read;
FLOAT_T stime_lap_em;
FLOAT_T stime_lap_memp;
FLOAT_T stime_lap_kl_dist;
FLOAT_T etime_lap_read;
FLOAT_T etime_lap_em;
FLOAT_T etime_lap_memp;
FLOAT_T etime_lap_kl_dist;

/* Global vars. for probabilistic inferences */
int num_class_opt;  /* optimal number of classes */
FREQ_PTR freq_list; /* occurrences of objects */
int total_freq;     /* total occurrences of objects */
int kmin;
int kmax;
int kstep;
int num_entry;      /* number of distinct objects */
int num_entry_pre;  /* number of distinct objects (preliminary) */
int entry_id;
FLOAT_T *param_c;        /* class parameters */
FLOAT_T *param_c_opt;    /* class parameters with the optimal number of classes */
FLOAT_T *param_c_best;   /* class parameters used in random restarts */
FLOAT_T *hparam_c;       /* class hyperparameters */
FLOAT_T *read_param_c;   /* temporary class parameters */
FLOAT_T *read_hparam_c;  /* temporary class hyperparameters */
FLOAT_T ***hparam_w;     /* attribute hyperparameters */
FLOAT_T **prob_comp;     /* complete probs. used in EM */
FLOAT_T *prob_incomp;    /* incomplete probs. used in EM */
FLOAT_T **prob_cond;     /* conditinal probs. used in EM */
FLOAT_T *expect_c;       /* expected occurrences of classes E[c] */
int log_likelihood_size; 
FLOAT_T *log_likelihood; /* log-likelihood */
FLOAT_T *log_prior;      /* log of the prior prob. */
FLOAT_T *lambda;         /* log of the a posteriori prob. (MAP), or the log-likelihood (ML)*/
FLOAT_T *log_likelihood_best;  /* log-likelihood with the best params in random restarts */
FLOAT_T *log_prior_best;       /* log of the prior prob. with the best params */
FLOAT_T *lambda_best;          /* lambda with the best params */
FLOAT_T final_log_likelihood;  /* converged log-likeilhood  */
FLOAT_T final_log_prior;       /* converged log of prior prob */
FLOAT_T final_lambda;          /* converged lambda */
FLOAT_T final_log_likelihood_best;  /* converged log-likeilhood with the best params */
FLOAT_T final_log_prior_best;       /* converged log of prior prob with the best params */
FLOAT_T final_lambda_best;          /* converged lambda with the best params */
FLOAT_T *ic;           /* model score which is specified in the command line */
FLOAT_T *bic;          /* BIC */
FLOAT_T *autoclass;    /* AutoClass */
int *num_word;            /* numbers of distinct attribute values */
char ***word_list;        /* lists of attribute values */
int *num_miss_w;         /* number of missing values */
int total_num_miss_w;    /* total number of missing values */
char **case_id_list;      /* list of case IDs */
char **ans_class_list;    /* list of answer classes */
int **word_freq_list;     /* numbers of occurrences of attribute values */
int **print_order;        /* ordered indexes of word_list to be printed */
int **cluster_case;       /* clusters of cases (by clusters) */
int *cluster_case_pred;   /* clusters of cases (by cases) */
int *cluster_case_freq;   /* sizes of case clusters */
int ***cluster_w;         /* cluster of disc attribute values (by clusters) */
int **cluster_w_freq;     /* sizes of disc att-val clusters */
int **cluster_w_pred;     /* cluster of disc attribute values (by attribute values) */
int ***cluster_g;         /* cluster of cont attribute values (by clusters) */
int **cluster_g_freq;     /* sizes of cont att-val clusters */
int **cluster_g_pred;     /* cluster of cont attribute values (by attribute values) */
FLOAT_T ***param_w;        /* attribute parameters */
FLOAT_T ***param_w_opt;    /* attribute parameters with the optimal number of classes */
FLOAT_T ***param_w_best;   /* attribute parameters used in random restarts */
FLOAT_T ***read_param_w;   /* temporary attribute parameters */
FLOAT_T ***read_hparam_w;  /* temporary attribute hyperparameters */
FLOAT_T ***expect_w;       /* expected occrrences of att-vals E[x_j|c] */
FLOAT_T **prob_w;          /* unconditional prob for disc attrs P(x_j) = \sum_c P(c)P(x_j|c) */
FLOAT_T **prob_g;          /* unconditional prob for cont attrs P(x_j) = \sum_c P(c)P(x_j|c) */
FLOAT_T **prob_mem_case;   /* membership probs for cases P(c|x_1,x_2,...,xJ) */
FLOAT_T ***prob_mem_w;     /* membership probs for discrete att-vals P(c|x_j) */
FLOAT_T ***prob_mem_g;     /* membership probs for continuous att-vals P(c|x_j) */
int **rank_mem_case;          /* relevance rankinng of cases */
int ***rank_mem_w;            /* relevance ranking of discrete att-vals */
int ***rank_mem_g;            /* relevance ranking of continuous att-vals */
VECTOR **param_u;             /* means for numeric attributes */
VECTOR **param_u_opt;         /* means for numeric attributes (with optimal number of clases) */
VECTOR **param_u_best;        /* means for numeric attributes (for random restarts) */
MATRIX **param_s;             /* covariances for numeric attrs */
MATRIX **param_s_opt;         /* covariances for numeric attrs (with optimal # of classes) */
MATRIX **param_s_best;        /* covariances for numeric attrs (for random restarts) */
MATRIX **param_p;             /* precision matrix (inverse of the covariance matrix) */
FLOAT_T **param_sdet;      /* determinants of the covariance matrices */
VECTOR **hparam_u;            /* hyperparameters of means for numeric attributes */
MATRIX **hparam_s;            /* hyperparameters of covariances for numeric attrs */
MATRIX **hparam_p;            /* hyperparameters of precisions */
FLOAT_T **hparam_sdet;     /* determinant of hparam_s */
FLOAT_T ***read_param_u;   /* temporary means for numeric attributes */
FLOAT_T ***read_hparam_u;  /* temporary hyperparameter of means for numeric attributes */
FLOAT_T ****read_param_s;  /* temporary covariances for numeric attrs */
FLOAT_T ****read_hparam_s; /* temporary hyperparameter of covariances for numeric attrs */
FLOAT_T *read_tau;         /* temporary tau in Normal-Wishart */
FLOAT_T **read_alpha_w;    /* temporary alpha in Normal-Wishart */
FLOAT_T *hparam_tau;       /* tau in Normal-Wishart (used in mode_read_hparam)   */
FLOAT_T **hparam_alpha_w;  /* alpha in Normal-Wishart (used in mode_read_hparam) */
VECTOR **expect_u;            /* expectations of means */
MATRIX **expect_s;            /* expectations of covariances */
VECTOR *avg_u;                /* means with no consideration about classes */
MATRIX *avg_s;                /* covariances with no consideration about classes */

/* Global vars. for the log on random restarts  */
unsigned int **log_seed;    /* random seeds */
int **log_num_iterate;      /* number of iterations for each trial */
int *log_r_best;            /* ID of the trial that yields the best parameters */
FLOAT_T **log_final_lambda;  /* converged lambda's */

/* Global vars. for SMEM */
int num_sm;                  /* number of split-merge operations */
int max_candidate;           /* maximum number of split-merge candidates */
int max_jsplit;              /* maximum number of split candidates for each merge candidate */
int mode_norm;               /* flag for normalizing Jmerge */
FLOAT_T min_param_c;      /* lower limit of the probabilities of classes to be split  */
FLOAT_T min_smem_improve; /* lower limit of the improvement obtained by a SM operation */
FLOAT_T min_new_param_c;  /* lower limit of the probabilities of new classes */
int **sm_candidate;          /* split-merge candidates */
FLOAT_T **jmerge;         /* Jmerge scores */
FLOAT_T *norm;            /* Euclid norm for normalizing Jmerge scores */
FLOAT_T *jsplit;          /* Jsplit scores */
FLOAT_T *param_c_sm;      /* temporary parameters for a SM operation */
FLOAT_T ***param_w_sm;    /* temporary attribute parameters for a SM operation */
FLOAT_T ***param_u_sm;    /* temporary means for a SM operation */
FLOAT_T ****param_s_sm;   /* temporary covariances for a SM operation */
int num_candidate;           /* current number of SM candidates */
int *num_iterate_sm_full;    /* number of full EM iterations */
int *num_iterate_sm_part;    /* number of partial EM iterations */
int *num_result_rejected;    /* number of rejected candidates */
int *num_result_skipped;     /* number of skipped candidates */
FLOAT_T *param_c_part;        /* class parameters used in partial EM */
FLOAT_T *prob_incomp_part;    /* incomplete probs used in partial EM */
FLOAT_T **prob_cond_part;     /* conditional probs used in partial EM */
int *log_likelihood_sm_size;     /* size of the arrays below */
FLOAT_T **log_likelihood_sm;  /* log-likelihood in partial EM */
FLOAT_T **log_prior_sm;       /* log of prior prob in partial EM */
FLOAT_T **lambda_sm;          /* lambda in partial EM */
FLOAT_T **log_itemp_sm;       /* inverse temperature in DAEM */

/* Global vars. for DAEM */
FLOAT_T itemp;            /* inverse temperature in DAEM */
FLOAT_T itemp_init;       /* initial value of inverse temperature in DAEM */
FLOAT_T itemp_rate;       /* update rate of inverse temperature in DAEM */
FLOAT_T *log_itemp;       /* record of inverse temperature in DAEM */
FLOAT_T *log_itemp_best;  /* record of inverse temperature in DAEM for the best run */
FLOAT_T itemp_best;       /* inverse temperature in best run */
int num_itemp;               /* Number of inverse temperatures examined in DAEM */  

/* Global vars. for user configuration */
int mode_verbose;                       /* flag: debugging of numerical computation */
int mode_em;                            /* flag: EM learning */
enum file_format format_in, format_out; /* flag: input/output in CSV form */
int mode_conv_in, mode_conv_out;        /* flag: code conversion for user */
int mode_sys_out;                       /* flag: code conversion for system (default code) */
FLOAT_T smooth_c;             /* smoothing constant for class */
FLOAT_T *smooth_w;            /* smoothing constants for attributes */
FLOAT_T smooth_u;             /* smoothing constant for means */
FLOAT_T smooth_s;             /* smoothing constant for variances */
FLOAT_T tau;                  /* weight of smoothing constant for means */
FLOAT_T alpha_w;              /* weight of smoothing constant for variances */
int mode_smooth;                 /* flag: smoothing mode */
int mode_smooth_gauss;           /* flag: smoothing mode for Gaussians */
int mode_smooth_auto;            /* flag: automatic smoothing configuration (total) */
int mode_smooth_strict;          /* flag: smoothing mode for AutoClass */
int mode_smooth_u;               /* flag: having explicit specification of smooth_u */
int mode_smooth_s;               /* flag: having explicit specification of smooth_s */
enum smooth_auto_type mode_smooth_auto_c;   /* flag:  auto smoothing config. (class) */
enum smooth_auto_type *mode_smooth_auto_w;  /* flags: auto smoothing config. (disc. attr) */
enum smooth_auto_type mode_smooth_auto_tau; /* flag:  auto smoothing config. (tau) */
int mode_bdeu;               /* flag: BDeu */
FLOAT_T bdeu_min_smooth;  /* minimum smoothing constant for BDeu */
int mode_memp;               /* flag: membership probability */
int mode_dist;               /* flag: dissimilarities */
int mode_search_num_class;   /* flag: model selection */
int mode_suffix;             /* flag: filename suffix */
int mode_cluster;            /* flag: clustering */
int mode_set_seed;           /* flag: manual setting of random seeds */
int mode_lex_order;          /* flag: displaying att-vals in the lexicographical order */
int mode_rank;               /* flag: relevance analysis */
int mode_rank_hide;          /* flag: hiding irrevant values in ranking */
int mode_rank_th;            /* flag: ranking with filtering by a threshold */
int mode_as_is;              /* flag: construncting a list of att-vals from the occurrence data*/
int mode_eval;               /* flag: clustering evaluation (not fully supported) */
int mode_read_hparam;        /* flag: reading smoothing constants from a file */
int mode_msg;                /* flag: writing summary messages to a file */
int mode_daem;               /* flag: enabling deterministic EM algorithm */
int mode_nominal;             /* flag: handling discrete attributes */
int mode_gauss;              /* flag: handling continuous attributes */
int mode_id;                 /* flag: specifying case ID */
int mode_ignore;             /* flag: specifying columns to be ignored */
int mode_hide_attr;          /* flag: hiding attributes in output files */
int num_rank;                /* number of relevant cases/att-vals to be output */
FLOAT_T rank_th;          /* threshold for relevant cases/att-vals */
int num_class;               /* number of classes */
int num_ans_class;           /* number of answer classes */
int num_case_id;             /* number of case IDs */
int attr_id;                 /* column index of case ID */
int *attr_ignore;            /* indices of the columns to be ignored */
int num_attr_ignore;         /* number of columns to be ignored */
int attr_eval;               /* column index of answer class */
int tuple_size;              /* number of attributes */
int tuple_size_d;            /* number of discrete attributes */
int tuple_size_c;            /* number of continuous attributes */
int tuple_size_all;          /* tuple_size_d + tuple_size_d */
int max_iterate;             /* max number of EM iterations */
int num_init;                /* number of restarts */
int max_init_iterate;        /* number of preliminary EM iterations in random restarts */
int mode_log_valued;         /* log-valued computation for ML/MAP */
FLOAT_T epsilon;          /* threshold for judginng convergence */
enum info_criterion_type ic_type;    /* model score */
enum cluster_type cl_type;           /* clustering score */
enum init_type_for_class init_type_class; /* initialization method for class params. */
enum init_type_for_word init_type_word;   /* initialization method for attr. params. */
enum relevance_measure rel_m;        /* relevance score */
char ic_type_str[ENUM_TYPE_LEN];     /* string representation of model score */
char cl_type_str[ENUM_TYPE_LEN];     /* string representation of clustering score */
char init_type_str_class[ENUM_TYPE_LEN]; /* string representation of class param initialization */
char init_type_str_word[ENUM_TYPE_LEN];  /* string representation of attr. param initialization */
char rel_m_str[ENUM_TYPE_LEN];       /* string representation of relevance score */
unsigned int rand_seed;              /* random seed */
int *rank_class;        /* ranking of classes according to the magnitude of class probs. */
#ifdef USE_ICONV
char charcode_in[CHARCODE_LEN];      /* input character code (iconv) */
char charcode_out[CHARCODE_LEN];     /* output character code (iconv) */
#endif
int prec_out;           /* number of digits after the decimal point (file output)      */
int prec_msg;           /* number of digits after the decimal point (terminal message) */
int mode_uncompress;    /* flag: uncompressing the cases that have the same attvals      */

/* Global vars. for hashtables */
HASHTABLE *ht;         /* array of hashtables for attributes */
HASHTABLE ht_vec;      /* hashtable for attribute vectors */
HASHTABLE ht_class;    /* hashtable for answer classes */
HASHTABLE ht_case_id;  /* hashtable for case IDs */

/* Global vars. for attribute information */
ATTR_INFO *attr_info;

/* Global vars. for gaussian distribution (continuous attributes) */
GAUSS_PTR gauss_list;
int gauss_size;
int *gauss_attr_size;
int **gauss_attr;

/* Matrix operations */
int err_inv;  /* indicator of errors in inverting a matrix */
int err_det;  /* indicator of errors in calculating the determinant of a matrix */
int err_lu;   /* indicator of errors in LU decomposition */
int err_cho;  /* indicator of errors in Cholesky decomposition */

/* Temporary area for EM */
int *freq_w_id;               /* temporary array for att-val IDs */

/* Temporary area for sorting */
char **tmp_word_list;

#endif /* NBC_VAR_H */
